/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */



/**
 *
 * @author wwerapun
 */


import java.util.ArrayList;
import java.util.Collection;
import java.util.PriorityQueue;

public class GraphPriorityQueue {


	private PriorityQueue<Node> pQueue = new PriorityQueue<Node>();

	/**
	 * Constructor
	 */
	public GraphPriorityQueue(){

	}
	/**
	 *
	 * @param n
	 */
	public void add(Node n){
		pQueue.add(n);
	}
	/**
	 *
	 * @param g
	 */
	public void add(Collection<Node> nodeCollection){
		this.pQueue.addAll(nodeCollection);
	}

	/**
	 *
	 * @return
	 */
	public Boolean hasMore(){
		return !this.pQueue.isEmpty();
	}

	/**
	 *
	 * @return
	 */
	public Node remove(){
		return this.pQueue.remove();
	}

	/**
	 * Removes desired graph node, then inserts into appropriate slot
	 *
	 * @param distance
	 */
	public void updateGraphNodeDistance(Node n){
		this.pQueue.remove(n);
		this.pQueue.add(n);
	}
	/**
	 * Print Contents
	 *
	 */
	public void PrintContents(){
		//it appears that order is preserved when items are removed from the collections
		ArrayList<Node> _temp = new ArrayList<Node>();
		System.out.println("Size of Q=" + pQueue.size());
		while (!pQueue.isEmpty()){
			Node n =pQueue.remove();
			_temp.add(n);
			System.out.println(n.label +" distance=" + n.distance );
		}
		pQueue.addAll(_temp);
	}

}
