/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import java.util.ArrayList;

/**
 *
 * @author wwerapun
 */
public class TestDijkstra {

    public static void main(String args[]) {

        ArrayList<Node> vNode = new ArrayList<Node>();

        Graph g = new Graph();

        for (int i = 0; i < 15; i++) {   //  create nodes
            vNode.add(new Node(new Integer(i).toString()));
            g.addNode((Node) vNode.get(i));
        }

        //Create the graph, add nodes, create edges between nodes
        int edge[][] = {{0, 1}, {0, 2}, {0, 3},
            {1, 4}, {1, 5}, {2, 5}, {2, 6}, {3, 7},
            {3, 8}, {3, 9}, {8, 9}, {9, 10}, {10, 14},
            {6, 11}, {6, 12}, {7, 13}, {6, 7}, {7, 14}, {3, 6},
            {7, 9}, {5, 6}};


        for (int i = 0; i < edge.length; i++) {
            g.connectNode((Node) vNode.get(edge[i][0]), (Node) vNode.get(edge[i][1]));
        }
        g.setRootNode((Node) vNode.get(0));

        Dijkstra dAlg = new Dijkstra(g);
        dAlg.go();
        System.out.println("\nShortest hop counts are: ");
        g.printAllNode();
        //dAlg.PrintStatusOfPriorityQ();

        //Perform the traversal of the graph
        g.clearNodes();
        System.out.println("\nBFS Traversal of a tree is ------------->");
        g.bfs();


        System.out.println("DFS Traversal of a tree is ------------->");
        g.dfs();

        
    }
}
